class Event {
    int count = 0;
    public synchronized void wait_for_event() {
        { try { wait(); } catch(InterruptedException e){ }; } 
    }
    public synchronized void signal_event() {
        count = (count + 1) % 3; 
        notifyAll(); 
    }
}

class Planner extends Thread {
    Event event1, event2; 
    int count = 0;
    
    public Planner(Event e1, Event e2) {
        this.event1=e1; this.event2=e2;
    }

    public void run() {
    int count = 0;
        while(true){
            if (count == event1.count) event1.wait_for_event();
            count = event1.count; 
            event2.signal_event();
        }
    }
}

class Executive extends Thread {
    Event event1, event2;
    int count = 0;

    public Executive(Event e1, Event e2) { 
        this.event1 = e1; this.event2 = e2;
    }

    public void run() {
        int count = 0;
        while(true){
            event1.signal_event();
            if (count == event2.count) event2.wait_for_event();
            count = event2.count;
        }
    }
}

class RemoteAgent {
    public static void main(String[] args) {
        Event new_event1 = new Event();
        Event new_event2 = new Event();
        Planner task1 = new Planner(new_event1, new_event2);
        Planner task2 = new Planner(new_event1, new_event2);
        task1.start(); task2.start();
    }
}
