class DiningPhilosophers  {

    public static void main(String[] args) {

        int count = 3;
        Fork[] forks = new Fork[count] ;

        for (int i = 0; i < count; i++){
           forks[i] = new Fork() ;
        }

        for (int i = 0; i < count; i++){
            (new Philosopher(i, forks[i], forks[(i + 1) % count])).start() ;
        }
      
	return;
    }
}


class Philosopher extends Thread {
    int id;
    Fork f1, f2;

    public Philosopher(int i,  Fork f1, Fork f2) {
	this.f1 = f1 ;
	this.f2 = f2 ;
	this.id = i ;
    }

    void dine() {
//        System.out.print("Philosopher #");
//        System.out.print(id);
//        System.out.println(" dined");
    }

    public void run() {

	synchronized (f1) {
	    synchronized (f2) {
		dine();
	    }
	}
    }
}


class Fork  {
    public int num;
}
